#ifndef __DRONEDGE_H__
#define __DRONEDGE_H__

#include <open62541/server.h>
#include "mavsdk_wrapper.h"
#include "pubsub.h"

UA_Double latitude = 0;
UA_Double longitude = 0;
UA_Float altitude_abs = 0;
UA_Float altitude_rel = 0;
UA_UInt32 last_checkpoint = 0;

VariableData droneVariableArray[] = {
    {
        .name = "latitude",
        .description = "Latitude",
        .value = &latitude,
        .type = UA_TYPES_DOUBLE,
        .builtInType = UA_NS0ID_DOUBLE,
        .getter.getDouble = mavsdk_getLatitude,
    },
    {
        .name = "longitude",
        .description = "Longitude",
        .value = &longitude,
        .type = UA_TYPES_DOUBLE,
        .builtInType = UA_NS0ID_DOUBLE,
        .getter.getDouble = mavsdk_getLongitude,
    },
    {
        .name = "altitude_abs",
        .description = "Absolute Altitude (AMSL)",
        .value = &altitude_abs,
        .type = UA_TYPES_FLOAT,
        .builtInType = UA_NS0ID_FLOAT,
        .getter.getFloat = mavsdk_getAltitude,
    },
    {
        .name = "altitude_rel",
        .description = "Relative Altitude",
        .value = &altitude_rel,
        .type = UA_TYPES_FLOAT,
        .builtInType = UA_NS0ID_FLOAT,
        .getter.getFloat = mavsdk_getAltitudeRel,
    },
    {
        .name = "last_checkpoint",
        .description = "Last checkpoint flown over",
        .value = &last_checkpoint,
        .type = UA_TYPES_UINT32,
        .builtInType = UA_NS0ID_UINT32,
        .getter.getUint32 = getLastCheckpoint
    },
};


#endif /* __DRONEDGE_H__ */
